"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.createInstance = void 0;

var _react = _interopRequireDefault(require("react"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance"); }

function _iterableToArray(iter) { if (Symbol.iterator in Object(iter) || Object.prototype.toString.call(iter) === "[object Arguments]") return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = new Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

var PropTypes;

try {
  PropTypes = require("prop-types");
} catch (e) {}

var isFunction = function isFunction(arg) {
  return typeof arg === "function";
};
/**
 * createInstance allows you to create instances of Async that are bound to a specific promise.
 * A unique instance also uses its own React context for better nesting capability.
 */


var createInstance = function createInstance() {
  var defaultProps = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  var displayName = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : "Async";

  var _React$createContext = _react.default.createContext(),
      Consumer = _React$createContext.Consumer,
      Provider = _React$createContext.Provider;

  var Async =
  /*#__PURE__*/
  function (_React$Component) {
    _inherits(Async, _React$Component);

    function Async(props) {
      var _this;

      _classCallCheck(this, Async);

      _this = _possibleConstructorReturn(this, _getPrototypeOf(Async).call(this, props));
      _this.start = _this.start.bind(_assertThisInitialized(_this));
      _this.load = _this.load.bind(_assertThisInitialized(_this));
      _this.run = _this.run.bind(_assertThisInitialized(_this));
      _this.cancel = _this.cancel.bind(_assertThisInitialized(_this));
      _this.onResolve = _this.onResolve.bind(_assertThisInitialized(_this));
      _this.onReject = _this.onReject.bind(_assertThisInitialized(_this));
      _this.setData = _this.setData.bind(_assertThisInitialized(_this));
      _this.setError = _this.setError.bind(_assertThisInitialized(_this));
      var promiseFn = props.promiseFn || defaultProps.promiseFn;
      var initialValue = props.initialValue || defaultProps.initialValue;
      var initialError = initialValue instanceof Error ? initialValue : undefined;
      var initialData = initialError ? undefined : initialValue;
      _this.mounted = false;
      _this.counter = 0;
      _this.args = [];
      _this.abortController = {
        abort: function abort() {}
      };
      _this.state = {
        initialValue: initialValue,
        data: initialData,
        error: initialError,
        isLoading: !initialValue && isFunction(promiseFn),
        startedAt: undefined,
        finishedAt: initialValue ? new Date() : undefined,
        counter: _this.counter,
        cancel: _this.cancel,
        run: _this.run,
        reload: function reload() {
          var _this2;

          _this.load();

          (_this2 = _this).run.apply(_this2, _toConsumableArray(_this.args));
        },
        setData: _this.setData,
        setError: _this.setError
      };
      return _this;
    }

    _createClass(Async, [{
      key: "componentDidMount",
      value: function componentDidMount() {
        this.mounted = true;
        this.state.initialValue || this.load();
      }
    }, {
      key: "componentDidUpdate",
      value: function componentDidUpdate(prevProps) {
        var _this$props = this.props,
            watch = _this$props.watch,
            _this$props$watchFn = _this$props.watchFn,
            watchFn = _this$props$watchFn === void 0 ? defaultProps.watchFn : _this$props$watchFn,
            promiseFn = _this$props.promiseFn;
        if (watch !== prevProps.watch) this.load();
        if (watchFn && watchFn(_objectSpread({}, defaultProps, this.props), _objectSpread({}, defaultProps, prevProps))) this.load();

        if (promiseFn !== prevProps.promiseFn) {
          if (promiseFn) this.load();else this.cancel();
        }
      }
    }, {
      key: "componentWillUnmount",
      value: function componentWillUnmount() {
        this.cancel();
        this.mounted = false;
      }
    }, {
      key: "start",
      value: function start() {
        if ("AbortController" in window) {
          this.abortController.abort();
          this.abortController = new window.AbortController();
        }

        this.counter++;
        this.setState({
          isLoading: true,
          startedAt: new Date(),
          finishedAt: undefined,
          counter: this.counter
        });
      }
    }, {
      key: "load",
      value: function load() {
        var promiseFn = this.props.promiseFn || defaultProps.promiseFn;
        if (!promiseFn) return;
        this.start();
        return promiseFn(this.props, this.abortController).then(this.onResolve(this.counter), this.onReject(this.counter));
      }
    }, {
      key: "run",
      value: function run() {
        var deferFn = this.props.deferFn || defaultProps.deferFn;
        if (!deferFn) return;

        for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
          args[_key] = arguments[_key];
        }

        this.args = args;
        this.start();
        return deferFn(args, _objectSpread({}, defaultProps, this.props), this.abortController).then(this.onResolve(this.counter), this.onReject(this.counter));
      }
    }, {
      key: "cancel",
      value: function cancel() {
        this.counter++;
        this.abortController.abort();
        this.setState({
          isLoading: false,
          startedAt: undefined,
          counter: this.counter
        });
      }
    }, {
      key: "onResolve",
      value: function onResolve(counter) {
        var _this3 = this;

        return function (data) {
          if (_this3.mounted && _this3.counter === counter) {
            var onResolve = _this3.props.onResolve || defaultProps.onResolve;

            _this3.setData(data, function () {
              return onResolve && onResolve(data);
            });
          }

          return data;
        };
      }
    }, {
      key: "onReject",
      value: function onReject(counter) {
        var _this4 = this;

        return function (error) {
          if (_this4.mounted && _this4.counter === counter) {
            var onReject = _this4.props.onReject || defaultProps.onReject;

            _this4.setError(error, function () {
              return onReject && onReject(error);
            });
          }

          return error;
        };
      }
    }, {
      key: "setData",
      value: function setData(data, callback) {
        this.setState({
          data: data,
          error: undefined,
          isLoading: false,
          finishedAt: new Date()
        }, callback);
        return data;
      }
    }, {
      key: "setError",
      value: function setError(error, callback) {
        this.setState({
          error: error,
          isLoading: false,
          finishedAt: new Date()
        }, callback);
        return error;
      }
    }, {
      key: "render",
      value: function render() {
        var children = this.props.children;

        if (isFunction(children)) {
          return _react.default.createElement(Provider, {
            value: this.state
          }, children(this.state));
        }

        if (children !== undefined && children !== null) {
          return _react.default.createElement(Provider, {
            value: this.state
          }, children);
        }

        return null;
      }
    }]);

    return Async;
  }(_react.default.Component);

  if (PropTypes) {
    Async.propTypes = {
      children: PropTypes.oneOfType([PropTypes.node, PropTypes.func]),
      promiseFn: PropTypes.func,
      deferFn: PropTypes.func,
      watch: PropTypes.any,
      watchFn: PropTypes.func,
      initialValue: PropTypes.any,
      onResolve: PropTypes.func,
      onReject: PropTypes.func
    };
  }
  /**
   * Renders only when deferred promise is pending (not yet run).
   *
   * @prop {Function|Node} children Function (passing state) or React node
   * @prop {boolean} persist Show until we have data, even while loading or when an error occurred
   */


  var Pending = function Pending(_ref) {
    var children = _ref.children,
        persist = _ref.persist;
    return _react.default.createElement(Consumer, null, function (state) {
      if (state.data !== undefined) return null;
      if (!persist && state.isLoading) return null;
      if (!persist && state.error !== undefined) return null;
      return isFunction(children) ? children(state) : children || null;
    });
  };

  if (PropTypes) {
    Pending.propTypes = {
      children: PropTypes.oneOfType([PropTypes.node, PropTypes.func]).isRequired,
      persist: PropTypes.bool
    };
  }
  /**
   * Renders only while loading.
   *
   * @prop {Function|Node} children Function (passing state) or React node
   * @prop {boolean} initial Show only on initial load (data is undefined)
   */


  var Loading = function Loading(_ref2) {
    var children = _ref2.children,
        initial = _ref2.initial;
    return _react.default.createElement(Consumer, null, function (state) {
      if (!state.isLoading) return null;
      if (initial && state.data !== undefined) return null;
      return isFunction(children) ? children(state) : children || null;
    });
  };

  if (PropTypes) {
    Loading.propTypes = {
      children: PropTypes.oneOfType([PropTypes.node, PropTypes.func]).isRequired,
      initial: PropTypes.bool
    };
  }
  /**
   * Renders only when promise is resolved.
   *
   * @prop {Function|Node} children Function (passing data and state) or React node
   * @prop {boolean} persist Show old data while loading
   */


  var Resolved = function Resolved(_ref3) {
    var children = _ref3.children,
        persist = _ref3.persist;
    return _react.default.createElement(Consumer, null, function (state) {
      if (state.data === undefined) return null;
      if (!persist && state.isLoading) return null;
      if (!persist && state.error !== undefined) return null;
      return isFunction(children) ? children(state.data, state) : children || null;
    });
  };

  if (PropTypes) {
    Resolved.propTypes = {
      children: PropTypes.oneOfType([PropTypes.node, PropTypes.func]).isRequired,
      persist: PropTypes.bool
    };
  }
  /**
   * Renders only when promise is rejected.
   *
   * @prop {Function|Node} children Function (passing error and state) or React node
   * @prop {boolean} persist Show old error while loading
   */


  var Rejected = function Rejected(_ref4) {
    var children = _ref4.children,
        persist = _ref4.persist;
    return _react.default.createElement(Consumer, null, function (state) {
      if (state.error === undefined) return null;
      if (state.isLoading && !persist) return null;
      return isFunction(children) ? children(state.error, state) : children || null;
    });
  };

  if (PropTypes) {
    Rejected.propTypes = {
      children: PropTypes.oneOfType([PropTypes.node, PropTypes.func]).isRequired,
      persist: PropTypes.bool
    };
  }

  Async.Pending = Pending;
  Async.Loading = Loading;
  Async.Resolved = Resolved;
  Async.Rejected = Rejected;
  Async.displayName = displayName;
  Async.Pending.displayName = "".concat(displayName, ".Pending");
  Async.Loading.displayName = "".concat(displayName, ".Loading");
  Async.Resolved.displayName = "".concat(displayName, ".Resolved");
  Async.Rejected.displayName = "".concat(displayName, ".Rejected");
  return Async;
};

exports.createInstance = createInstance;

var _default = createInstance();

exports.default = _default;